<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xlf="urn:oasis:names:tc:xliff:document:1.2"
	xmlns:xt="xsl:transformer"
	exclude-result-prefixes="xlf xt">

	<xsl:output method="text" encoding="UTF-16"/>

	<xsl:param name="languageCode"/>

	<xsl:param name="transUnitId"/>

	<xsl:param name="variables"/>

	<xsl:variable name="xtVariables" select="msxsl:node-set($variables)"
		xmlns:msxsl="urn:schemas-microsoft-com:xslt"/>
    
	<xsl:template match="/">
		<xsl:apply-templates select="xlf:xliff/xlf:file"/>
	</xsl:template>

	<xsl:template match="/xlf:xliff/xlf:file">
		<xsl:choose>
			<xsl:when test="@source-language = $languageCode and not(@target-language)">
				<xsl:apply-templates select="xlf:body/xlf:trans-unit[@id = $transUnitId]/xlf:source/node()"/>
			</xsl:when>
			<xsl:when test="@target-language = $languageCode">
				<xsl:apply-templates select="xlf:body/xlf:trans-unit[@id = $transUnitId]/xlf:target/node()"/>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="xlf:x[@ctype = 'x-variable']">
		<xsl:variable name="id" select="@id"/>
		<xsl:value-of select="$xtVariables/xt:variable[@id = $id]"/>
	</xsl:template>

	<xsl:template match="xlf:x[@ctype = 'x-linebreak']">
		<xsl:text>&#xA;</xsl:text>
	</xsl:template>
    
	<xsl:template match="xlf:x[@ctype = 'x-space']">
		<xsl:text>&#x20;</xsl:text>
	</xsl:template>

	<xsl:template match="xlf:x[@ctype = 'x-nbsp']">
		<xsl:text>&#160;</xsl:text>
	</xsl:template>

	<xsl:template match="xlf:x[@ctype = 'x-tab']">
		<xsl:text>&#x9;</xsl:text>
	</xsl:template>

	<xsl:template match="text()">
		<xsl:value-of select="normalize-space()"/>
	</xsl:template>

</xsl:stylesheet>